#include <sdl/sdl.h>

#pragma comment(lib,"sdl.lib")
#pragma comment(lib,"sdlmain.lib")

#define SPEED -1
#define IMX 368
#define IMY 388

SDL_Surface* Charger(const char* fic)
{
	SDL_Surface *res;
	SDL_Surface* tmp = SDL_LoadBMP(fic);
	if (tmp==NULL)
	{
		printf("Erreur chargement %s\n",fic);
		exit(-1);
	}
	res = SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	return res;
}

int KeyHit()
{
	SDL_Event e;
	if (SDL_PollEvent(&e))
		if (e.type == SDL_KEYDOWN)
			return 1;
	return 0;
}

int negatmodulo(int x,int mod)
{
	if (x>=0)
		return x%mod;
	return (x%mod)+mod;
}

int main(int argc,char** argv)
{
	SDL_Surface* fond,*screen;
	int x = 0;
	SDL_Init(SDL_INIT_VIDEO);
	screen=SDL_SetVideoMode(IMX,IMY,32,SDL_SWSURFACE|SDL_DOUBLEBUF);  
	fond=Charger("fond.bmp");
	while(!KeyHit())
	{
		SDL_Rect R;
		R.x = negatmodulo(x,IMX);
		R.y = 0;
		SDL_BlitSurface(fond,NULL,screen,&R);
		R.x = negatmodulo(x,IMX) - IMX;
		SDL_BlitSurface(fond,NULL,screen,&R);
		x+=SPEED;
		SDL_Flip(screen);
		SDL_Delay(3);
	}
	SDL_FreeSurface(fond);
	SDL_Quit();
	return 0;
}

/*!F
	Un petit exemple pour montrer un scrolling simple.
	Un scrolling est un dfilement d'cran.

	Lancez le programme, vous voyez le fond dfiler.
	Notez que, comme fond, j'ai pris une image ou la partie droite concide avec la partie gauche : c'est  dire que si vous collez 2 images cote  cote,
	vous ne voyez pas les jointures. 

	Quelques petites explications.
	
	Le main :
	---------

	Je dfinis une variable x  qui sera la coordonne de fentrage, c'est  dire que si on imagine un monde gant, c'est la coordonne x de ma fentre.
	En faisant incrmenter ou dcrmenter x, je dfile.

	Je vais afficher deux images cte  cote, dpendant de x, ou pltot du modulo de X par la largeur de X IMX.

	Au lieu d'utiliser directement le modulo, j'utilise une fonction. Car contrairement  l'oprateur %, je veux une valeur entre 0 et IMX-1 
	et ce mme si x est ngatif, alros que le modulo natif va me donner une valeur entre -IMX+1 .. IMX-1

	Je blit les deux images cte  cte. Inutile de dcouper moi mme les images (la partie visible), 
	la fonction SDL_BlitSurface s'en charge automatiquement.

	Le SDL_Delay permet de ralentir un peu le rythme : comme la fentre est petite, si je ne fais pas a, a va trop vite. Essayez donc :)
!*/

/*!E
	No explanations yet.
!*/

/*
titre: Scrolling simple.
titreE: Simple Scrolling.
meta: C;SDL;scroll
metaE: C;SDL;scroll
desc : Dfilement d'cran.
descE : Scrolling.
cle  : 
linkA: fond.bmp
*/
